// mvport package v2
// Author: Alberto Dorantes, July, 2016
// cdorante@itesm.mx
version 11.0
mata:
mata set matastrict on
real vector function m_ovportws(real scalar rfrate, real matrix covmatrix, real matrix mrets)
{
real matrix UNOS, COV, INVCOV, A, B, C, D, W, MR, E

real scalar retp, riskp, varp

COV=covmatrix
MR=mrets

INVCOV=cholinv(COV)
if (missing(INVCOV[1,1])) {
  printf("The VAR-COVAR Matrix is NOT positive definite. It will be estimated with general inverse function.\n")
  INVCOV=invsym(COV)
}

UNOS=J(cols(COV),1,1)
  
E=rowsum(INVCOV)
B=MR'*E
C=sum(INVCOV)
                           
W= (INVCOV*(MR-rfrate*UNOS)) / (B - C*rfrate)
return(W)
}
end
mata: mata mosave m_ovportws(), dir(PERSONAL) replace
